// border style

@use 'fun';

// none
// [width] style [color]
@mixin border($value) {
  border: $value;
}

@mixin border-none() {
  @include border(none);
}

// <length> <percentage>
@mixin border-radius($value) {
  border-radius: $value;
}

// vertical: top bottom start end
// horizontal: left right start end
// value: <length> <percentage>
@mixin border-direction-radius($vertical, $horizontal, $value) {
  border-#{$vertical}-#{$horizontal}-radius: $value;
}

// thin medium thick <length>
@mixin border-width($value) {
  border-width: $value;
}

// side: top bottom left right
// value: thin medium thick <length>
@mixin border-side-width($side, $value) {
  border-#{$side}-width: $value;
}

// inherit currentColor transparent
// see typography.color
@mixin border-color($value: inherit) {
  border-color: $value;
}

// solid dashed dotted double none
@mixin border-style($value) {
  border-style: $value;
}

// side: top bottom left right
// value: solid dashed dotted double none
@mixin border-side-style($side, $value) {
  border-#{$side}-style: $value;
}

// collapse separate
@mixin border-collapse($value) {
  border-collapse: $value;
}

// <length>
// <horizontal length> <vertical length>
@mixin border-spacing($value) {
  border-spacing: $value;
}

// [inset] offset-x offset-y [blur-radius [spread-radius]] color
@mixin box-shadow($value) {
  @include fun.prefix-add-moz('box-shadow', $value);
}

// none
// [color] style [width]
@mixin outline($value) {
  outline: $value;
}

@mixin outline-none() {
  @include outline(none);
}

// auto none dotted dashed solid double groove ridge inset outset
@mixin outline-style($value) {
  outline-style: $value;
}

// thin medium thick OR size
@mixin outline-width($value) {
  outline-width: $value;
}

@mixin outline-offset($value) {
  outline-offset: $value;
}

// inherit currentColor transparent
// see typography.color
@mixin outline-color($value: inherit) {
  outline-color: $value;
}
